const axios = require('axios').default;
const baseURL = 'https://auralist.ml/api/v1'

class Searcher  {
    constructor(apiToken) {
        if (!apiToken)
            throw new TypeError("No se ha especificado el token de la API.");
        this.apiToken = apiToken;
    }
    async getBot(id) {
        if (isNaN(id))
            throw new TypeError("ID de bot inválida.");
        return new Promise(async (resolve, reject) => {
            await axios.get(baseURL + `/bots/${id}`, {
                headers: {
                    'Authorization': this.apiToken
                }
            })
            .then(res => {
                resolve(res.data)
            })
            .catch(res => {
                console.log(res.response.status)
                if (res.response.status == 404) return resolve(null);
                if ([400, 401].includes(res.response.status)) return reject(new Error(res.response.data.message));
                reject(new Error("Hubo un error al fetchear los datos del bot, intenta despúes.")) // Actually an error from server side;
            });
        });
    }
}
module.exports = Searcher;